<script lang="ts" setup>
  import { ParticipantState } from '~/logic/interfaces';
  import { ParticipantsControlKey } from '~/helpers/injection';

  defineEmits<{
    (e: 'close'): void;
  }>();

  const { isGuide } = useUser();
  const { isAppointmentRunning } = useAppointment();
  const participantStatisticsModalController = useModal();
  const { activeParticipants, inactiveParticipants, notJoinedParticipants, setControlledClient } =
    useParticipants();

  const actForUser = (participant: ParticipantState) => {
    setControlledClient(participant.attendeeId);
  };

  const openStatistics = (participant: ParticipantState) => {
    participantStatisticsModalController.open(participant);
  };

  provide(ParticipantsControlKey, {
    openStatistics,
    actForUser,
  });

  const displayedActiveParticipants = computed(() => {
    const regex = new RegExp(searchValue.value, 'i');
    return activeParticipants.value.filter((participant) => regex.test(participant.attendeeName));
  });

  const displayedInactiveParticipants = computed(() => {
    const regex = new RegExp(searchValue.value, 'i');
    return inactiveParticipants.value.filter((participant) => regex.test(participant.attendeeName));
  });

  const displayedNotJoinedParticipants = computed(() => {
    const regex = new RegExp(searchValue.value, 'i');
    return notJoinedParticipants.value.filter((participant) =>
      regex.test(participant.attendeeName),
    );
  });

  const searchValue = ref();

  const onSearchChanged = (val: string) => {
    const temp = val.replace(/[.*+?^${}()|[\]\\]/g, '\\$&');
    searchValue.value = temp;
  };

  const noParticipantsFound = computed(() => {
    return (
      (isGuide.value &&
        displayedInactiveParticipants.value.length === 0 &&
        displayedActiveParticipants.value.length === 0 &&
        displayedNotJoinedParticipants.value.length === 0) ||
      (!isGuide.value && displayedActiveParticipants.value.length === 0)
    );
  });
</script>

<template>
  <SwSidebar :show-back-btn="false" @close="$emit('close')">
    <template #header>
      <ParticipantsSidebarHeader
        :total-inactive="isGuide ? inactiveParticipants.length : undefined"
        :total-joined="activeParticipants.length"
      >
        <SwSearchInput class="mt-4" @change="onSearchChanged" />
      </ParticipantsSidebarHeader>
    </template>

    <template #body>
      <ParticipantsNotJoined
        v-if="isGuide"
        class="p-6"
        :participants="displayedNotJoinedParticipants"
      />

      <ParticipantsInactive
        v-if="isGuide"
        class="p-6"
        :participants="displayedInactiveParticipants"
      />

      <ParticipantsInPresentation class="p-6" :participants="displayedActiveParticipants" />

      <div
        v-if="noParticipantsFound"
        class="flex h-full flex-col items-center justify-center p-10 text-center"
      >
        <div class="bg-background-raised text-information-subdued mb-4 rounded-full p-6">
          <span class="i-sw-solid:users" />
        </div>
        <p class="text-(base information-dark) mb-1 font-semibold">
          {{ $t('presentation.participants.noParticipantsJoinedYet') }}
        </p>
      </div>
    </template>

    <template #footer>
      <ParticipantsSidebarFooter v-if="isGuide && isAppointmentRunning" />
    </template>
  </SwSidebar>
  <ParticipantStatisticsModal
    v-if="participantStatisticsModalController.isOpen.value"
    :controller="participantStatisticsModalController"
    :participant="participantStatisticsModalController.data.value"
  />
</template>
